<?php
/*
 *Plugin Name: SmilePayC2C(PAY)
 *Description: SmilePay 7-11 c2c Shipping
 * Version: 3.5.8
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
*/
 
/**
 * Check if WooCommerce is active
 */

/*if(!defined('SMILEPAY_C2CP_CHECK_CVS_STORE_SELECTED'))
    define('SMILEPAY_C2CP_CHECK_CVS_STORE_SELECTED',true);
    */
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_action('plugins_loaded', 'Smilepayc2cp_shipping_method_init', 0);
 
    add_action('woocommerce_checkout_update_order_review','Smilepayc2cp_shipping_method_match');
    add_action('woocommerce_checkout_init','Smilepayc2cp_shipping_method_match');//20200219ץhookJI
	
    add_action('before_woocommerce_pay','Smilepayc2cp_shipping_method_match_orderpay');
  
    /*add_action( 'admin_head', 'smilepayc2cp_admin_head' );
    function smilepayc2cp_admin_head()
    {
         global $pagenow;
          
         if($pagenow=='admin.php' && $_GET['page']=='wc-settings'&& $_GET['tab']=='shipping')
         {
               wp_register_script('smilepay_shipping_setting',plugins_url('js/sp_shipping_setting.js', __FILE__),
                                    array('wc-enhanced-select','jquery','wc-shipping-zone-methods'));
               wp_enqueue_script( 'smilepay_shipping_setting' );
             
         }
    }
    */

    //te覡LoIڤ覡
    function Smilepayc2cp_shipping_method_match()
    {
        global $smilepay_load_shipping_method;
        if ( WC()->cart->needs_shipping() ) {
            $packages = WC()->cart->get_shipping_packages();
            $payment_gateways = WC()->payment_gateways();
            $smilepay_c2cp_service_id = WC_Smilepayc2cp_Shipping_Method::getSupport_Service();
            if(!isset($smilepay_load_shipping_method) || $smilepay_load_shipping_method==false)
            {
                foreach ( $packages as $package_key => $package ) 
                {
                    WC()->shipping()->load_shipping_methods( $package );
           
                }
                $smilepay_load_shipping_method =TRUE;
            }
            
            $shipping_methods =  WC()->shipping()->shipping_methods;
            
         
            foreach($shipping_methods as $shipping_method)
            {
               if( in_array($shipping_method->id,$smilepay_c2cp_service_id) && $shipping_method->get_instance_id() != 0)
               {
                   $smilepay_c2cp_shipping_method =  $shipping_method;
            
                   break;
               }
           
            }
            if( isset($smilepay_c2cp_shipping_method) &&  $smilepay_c2cp_shipping_method)
            {
                if($smilepay_c2cp_shipping_method->enabled!="yes")
                    return;
                if($smilepay_c2cp_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                    return;
           
            }

            if(isset($_REQUEST['shipping_method'][0] ))
                $selected_shipping_method = $_REQUEST['shipping_method'][0] ;
            else
            {
                $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
                //if(empty($chosen_methods))
               // {
                 //   WC()->cart->calculate_shipping();
                  //  $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
                    if(empty($chosen_methods))
                        return;
              //  }
                   
                $selected_shipping_method = $chosen_methods[0]; 
            }
                
            foreach ( $payment_gateways as $payment_gateway ) {
                 foreach ( $payment_gateway as $gateway ) {
                        if( in_array(strtolower($selected_shipping_method),$smilepay_c2cp_service_id))
                        {
                            if($gateway->id != 'smilepayc2c')
                                $gateway->enabled = 'no';
                            else //change icon
                                $gateway->selectedIcon(WC_Smilepayc2cp_Shipping_Method::getCSVServiceArg(strtolower($selected_shipping_method)));
                        }
                        else
                        {
                            if($gateway->id == 'smilepayc2c')
                                $gateway->enabled = 'no';
                        }

                 }
            }
        } 
      
    }
    //te覡LoIڤ覡 b
    function Smilepayc2cp_shipping_method_match_orderpay()
    {
        global $wp;

        if ( isset( $_GET['pay_for_order']) && $_GET['pay_for_order'] == 'true') 
        {
            $order_id = $wp->query_vars['order-pay'];
            
            if($order_id)
            {
                $smilepay_c2cp_service_id = WC_Smilepayc2cp_Shipping_Method::getSupport_Service();
                $order = wc_get_order( $order_id ); 
                if(!$order)
                    return;
                //$packages = WC()->cart->get_shipping_packages();
                
                //make fake package for find shipping region
                $packages = array();
                $packages[0]['destination']['country']   =  $order->get_shipping_country();
			    $packages[0]['destination']['state']     =  $order->get_shipping_state();
			    $packages[0]['destination']['postcode']  =  $order->get_shipping_postcode();
			    $packages[0]['destination']['city']      =  $order->get_shipping_city();
			    $packages[0]['destination']['address']   =  $order->get_shipping_address_1();
			    $packages[0]['destination']['address_2'] =  $order->get_shipping_address_2();

                //load shipping method
                foreach ( $packages as $package_key => $package ) 
                {
                     WC()->shipping()->load_shipping_methods( $package );
                }
              
                $shipping_methods =  WC()->shipping()->shipping_methods;
                $payment_gateways = WC()->payment_gateways();
                
                foreach($shipping_methods as $shipping_method)
                {

                    if( in_array($shipping_method->id,$smilepay_c2cp_service_id) && $shipping_method->get_instance_id() != 0)
                    {
                        $smilepay_c2cp_shipping_method =  $shipping_method;
                        break;
                    }
                }

                if( isset($smilepay_c2cp_shipping_method) &&  $smilepay_c2cp_shipping_method)
                {
                    if($smilepay_c2cp_shipping_method->enabled!="yes")
                        return;
                    if($smilepay_c2cp_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                        return;
                }

                foreach($smilepay_c2cp_service_id as $service_id)
                {
                    $selected_shipping_method =    $order->has_shipping_method($service_id);
                    if( $selected_shipping_method)break;
                }

                foreach ( $payment_gateways as $payment_gateway ) {
                    foreach ( $payment_gateway as $gateway ) {
                        if($selected_shipping_method)
                        {
               
                            if($gateway->id != 'smilepayc2c')
                                $gateway->enabled = 'no';
                        }
                        else
                        {
                            if($gateway->id == 'smilepayc2c')
                                $gateway->enabled = 'no';
                        }   

                    }
                }

            }
            else
                return;
        }
    }


	function  Smilepayc2cp_shipping_method_init() {

      
		if ( ! class_exists( 'WC_Smilepayc2cp_Shipping_Method' ) ) {
            
            add_action('woocommerce_after_checkout_validation', 'WC_Smilepayc2cp_Shipping_Method::checkout_validate',10,2);
            add_action('woocommerce_after_shipping_rate','WC_Smilepayc2cp_Shipping_Method::shipping_emap_region');
            add_action( 'wc_ajax_smilepay_c2cp_save_emap', 'WC_Smilepayc2cp_Shipping_Method::ajax_save_emap' );
			class WC_Smilepayc2cp_Shipping_Method extends WC_Shipping_Method {
                const SMILEPAYC2CP_METHOD_ID_711 = 'smilepay_711_c2c_shippingpay';
                const SMILEPAYC2CP_METHOD_ID_FAMI = 'smilepay_fami_c2c_shippingpay';
                protected static $installed_hook=FALSE;
                private static $support_service = array(
                                                   '711' => self::SMILEPAYC2CP_METHOD_ID_711,
                                                   'fami'=> self::SMILEPAYC2CP_METHOD_ID_FAMI
                                                );
                protected static $smilepay_payzg_sub_tb = array(
                                                        '711' => '7NET',
                                                        'fami' => 'FAMI'
                                                    );
                protected static $service_cvs_name = array(
                                                        '711' => '7-11',
                                                        'fami' => 'a'
                                                    );
                protected static $service_cvs_query_shipment_url = array(
                                                                        '711' => 'https://eservice.7-11.com.tw/E-Tracking/search.aspx',
                                                                        'fami' => 'https://www.famiport.com.tw/Web_Famiport/page/process.aspx'
                                                                     
                                                                    );
                private static $map_url = array(
                                                   '711' => array(
                                                                'mobile'=>'https://emap.presco.com.tw/c2cemapm-u.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s',
                                                                'normal'=>'https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s'
                                                            ),
                                                   'fami'=>  array(
                                                                'mobile'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s',
                                                                'normal'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s'
                                                            ),
                                                );

                private static $map_save_type = array(
                                                    self::SMILEPAYC2CP_METHOD_ID_711 =>'711',
                                                    self::SMILEPAYC2CP_METHOD_ID_FAMI =>'fami'
                                                );
                
				public function __construct($instance_id = 0) {
                    include_once("smilepayc2c.php");

                    $this->instance_id 			 = absint( $instance_id );

                  
                    //$smilepayc2cdata = new WC_SmilePayc2c();
                    
					$this->id                 = 'smilepay_711_c2c_shippingpay';
					$this->method_title       = __( 'SmilePay CVStore Shipping(PAY)' ); 
                    $this->method_description    = u2bcp('WӨfI');

                    $this->service_id   = array(
                                            '711' => self::SMILEPAYC2CP_METHOD_ID_711,
                                            'fami' => self::SMILEPAYC2CP_METHOD_ID_FAMI,
                                          );
                    


                    //for woocommerce 2.6 modify
					//$this->enabled            = "yes";
                    $this->supports              = array(
			                                        'shipping-zones',
			                                        'instance-settings',
			                                        'instance-settings-modal',
		                                            );

                    /*if(isset($smilepayc2cdata->title) && !empty($smilepayc2cdata->title))
					    $this->title              = $smilepayc2cdata->title;//u2bcp("tRt7-11fI"); 
                    else
                        $this->title              = u2bcp("SmilePay 7-11WӨfI úO"); */
                    $this->title              = u2bcp("tRt WӨfI");
					$this->init();

                    $this->service_name   = array(
                                            '711' => $this->_711_title,
                                            'fami' => $this->fami_title
                                            );
                    if( empty($this->service_name['711']))
                        $this->service_name['711'] =u2bcp('tRt 7-11fI');

                    if( empty($this->service_name['fami']))
                        $this->service_name['fami'] =u2bcp('tRt afI');
				}
                


				public function init_form_fields() {  //x]m

					//for woocommerce 2.6 modify
					//$this->form_fields = array(
                    $this->instance_form_fields = array(
					/*	'enabled' => array(
							'title' => __(u2bcp("ҥ/"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' =>  $this->title,
						),*/
                        array( 'title' => u2bcp('7-11fIڳ]w'), 'type' => 'title', 'id' => 'smilepayc2cp_711_title' ),
                        '711_enabled' => array(
							'title' =>  u2bcp("7-11Wӱҥ"),
                            'description' => u2bcp("}Ҧ\Ate覡|h@7-11fIڿﶵ"),
							'type' => 'checkbox',
							'default' => 'no',
                   			'label' => u2bcp("ҥ"),
						),	

                        '711_title' => array(
							'title' =>  u2bcp("te覡W(7-11)"),
                            'description' => u2bcp("exܪteW"),
							'type' => 'text',
							'default' => u2bcp('tRt 7-11WӨfI'),
                   			'label' => u2bcp("exW(7-11)"),
						),	
                         'fee' => array(
							'title'       => u2bcp('O(7-11)'),
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),

                        array( 'title' => u2bcp('afIڳ]w'), 'type' => 'title', 'id' => 'smilepayc2cp_fami_title' ),

                        'fami_enabled' => array(
							'title' =>  u2bcp("aWӱҥ"),
                            'description' =>u2bcp( "}Ҧ\Ate覡|h@ӥafIڿﶵ"),
							'type' => 'checkbox',
							'default' => 'no',
                   			'label' => u2bcp("ҥ"),
						),	

                        'fami_title' => array(
							'title' =>  u2bcp("te覡W(a)"),
                            'description' => u2bcp("exܪteW"),
							'type' => 'text',
							'default' => u2bcp('tRt aWӨfI'),
                   			'label' =>u2bcp( "exW(a)"),
						),	
                         'fami_fee' => array(
							'title'       => u2bcp('O(a)'),
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
                        array( 'title' => u2bcp('@q]w'), 'type' => 'title', 'id' => 'smilepayc2cp_title' ),
						/*'fee' => array(
							'title'       => __(u2bcp('O'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),*/
						'fee_top' => array(
							'title'       => __(u2bcp('KBOe'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __(u2bcp("F즹BɡAKBOAϥνЫOť"), 'woocommerce'),
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
                        'min_total' => array(
							'title'       => u2bcp('̧COB'),
							'type'        => 'price',
							'description' => u2bcp('qBF즹]wBA~iHϥΦte覡AtBO'),
							'default'     => '',
						),					
                        'payment_filter_enabled' => array(
							'title' =>  u2bcp("SmilePay te覡ftIڤ覡Wh"),
                            'description' => __(u2bcp("}Ҧ\AbbɡAte覡OfIڡAIڤ覡ufIڡAYte覡OfIڡAhIڤ覡|X{fI"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' => u2bcp("ҥ"),
						),	
                        'restric_categories' => array(
                                                'title'             => u2bcp('ӫ~O'),
				                                'type'              => 'multiselect',
				                                'class'             => 'wc-enhanced-select',
				                                'css'               => 'width: 400px;',
				                                'default'           => '',
				                                'description'       => u2bcp('Oӫ~iHϥΦte覡<br>hLctrlI<br>LctrlAIzwgQ<br>'),
				                                'options'           =>$this->get_all_categorys(),
				                                'custom_attributes' => array(
					                                'data-placeholder' => u2bcp('Oӫ~'),
				                            ),
                         ),		
						'hiddtext' => array(
							'title' => __(u2bcp('Wӯ¨f`Nƶ'), 'woocommerce'),
							'type' => 'hidden',
							'description' => __(u2bcp("ϥζWӯ¨f\Aݪ`NHUƶG
														<br><font color='red'>ҲնȤ䴩iSmilePay WӨfIڡjyҲաAнT{ҥ</font>							
														<br>1.ХSmilePayӮax}Ҩf\*<a target='_blank' href='http://www.smilepay.net/RVG.ASP'>Ӯax</a>*
														<br>2.bT<font color='red'>pq</font><font color='red'>X</font>Aӫ~ɷ|H²TqC
														<br>3.O̦߭qAiSmilePayӮaxo<font color='red'>fKNX</font>C
														<br>4.O̦߭qAiܭqƵI<font color='red'>}ҥfKAȳ</font>C														
														<br>5.бN<font color='red'>fKNX</font>ʷsWܰӫ~ƵAHQO̬dߪyAC
														<br>6.hаѾ\A<font color='red'>SmilePay</font>P<font color='red'>WooCommerceҲջ</font>C
														"), 'woocommerce'),
							'default' => __('', 'woocommerce')
						)         
					);
				}
 
				function init() {
					$this->init_form_fields(); 
					//$this->init_settings();
					$this->fee          = $this->get_option( 'fee' );
                    $this->fami_fee          = $this->get_option( 'fami_fee' );

                    $this->_711_enabled = $this->get_option( '711_enabled' );
                    $this->fami_enabled = $this->get_option( 'fami_enabled' );
                    

                    $this->_711_title = $this->get_option( '711_title' );
                    $this->fami_title = $this->get_option( 'fami_title' );

                    $this->restric_categories = $this->get_option('restric_categories');
                    
					$this->fee_top= $this->get_option( 'fee_top' );	
                    $this->min_total =$this->get_option('min_total');	
                    $this->payment_filter_enabled= $this->get_option( 'payment_filter_enabled' );									
					add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
                    /*if(!self::$installed_hook)
					{
                        if($this->instance_id >0 &&  $this->enabled == 'yes' )
                        {
                            
                        }
                        self::$installed_hook=TRUE;
                    }*/
				}
                static function checkout_validate( $data, $errors )
                {
                    
                   //$shipping_methods =$data['shipping_method'];
                   if ( WC()->cart->needs_shipping() ) {
                        $chosen_shipping_methods = WC()->session->get( 'chosen_shipping_methods' );
                        $chosen_payment_method = WC()->session->get( 'chosen_payment_method' ); 
                        $find_shipping_method=FALSE;
                        foreach($chosen_shipping_methods as $shipping_method)
                        {
                            if(self::isSupport_Service($shipping_method))
                            {
                                $find_shipping_method=TRUE;
                                if(defined("SMILEPAY_C2CP_CHECK_CVS_STORE_SELECTED") && SMILEPAY_C2CP_CHECK_CVS_STORE_SELECTED ==true)
                                {
                                    if(!self::checkout_is_selected_emap($shipping_method))
                                        $errors->add( 'shipping',u2bcp("fܡAХܨfA~򧹦bA¡C<br>"));
                                }
                            }
                        }
                        if( $find_shipping_method)
                        {
                        
                            $username=$data['billing_first_name'].$data['billing_last_name'];
                            if( !preg_match("/[^a-zA-Z0-9 ]/",$username))
                            {
                                $limit_name_number =10;
                            }
                            else
                            {
                                $limit_name_number =5;
                            }
				            if(substr($data['billing_phone'],0,2)!="09"||mb_strlen($data['billing_phone'])!=10||mb_strlen( $username, "utf-8")>$limit_name_number){
                               $errors->add( 'shipping',u2bcp("<br>qܮ榡~Ad09XX123456(@10X)C<br>O̩mWiWL5ӦrA­^hiWL10ӦrCЦAT{C<br>"));
                   
				            }
                            if(strtolower($chosen_payment_method) != 'smilepayc2c' )
                            {
                               $errors->add( 'shipping',u2bcp("<br>Iڤ覡ܿ~Ate覡iӥIڤ覡AЧ󴫨@<br>"));
                            }
                            
                        }
                   }

                }
				/**
				 * calculate_shipping function.
				 *
				 * @access public
				 * @param mixed $package
				 * @return void
				 */
				public function calculate_shipping( $package = array() ) {
					$shipping_total=0;
					$fee_top=$this->fee_top;
					$total = WC()->cart->cart_contents_total;	
                    
                    if($this->restric_categories)
                    {
                       //foreach ( $package as  $package_items ) 
                       if(isset($package['contents']))
                       {
                           foreach ( $package['contents'] as $package_item ) 
                           {
                               $product_categories =$package_item['data']->get_category_ids();
                               foreach($product_categories as $product_categories_id)
                               {
                                   if(in_array($product_categories_id,$this->restric_categories))
                                    return FALSE;
                               }
                           }
                       }              
                    }	

                    if($this->_711_enabled == "yes")
                    {
                        $shipping_total=$this->fee;	
                        //if(isset($outside_fee))
                         //   $shipping_total += $outside_fee;
					    if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					    {$shipping_total=0;}
                        $rate = array(
						    'id' => $this->service_id['711'],
                            'method_id' => $this->service_id['711'],
						    'label' =>$this->service_name['711'],
						    'cost' => $shipping_total
					    );
                        // Register the rate
                        if($total >= $this->min_total)
                            $this->add_rate( $rate );
                    }
                    
                    if($this->fami_enabled == "yes")
                    {
                        $shipping_total=$this->fami_fee;	
                        //if(isset($outside_fee))
                         //   $shipping_total += $outside_fee;
					    if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					    {$shipping_total=0;}
                        $rate = array(
						    'id' => $this->service_id['fami'],
						    'label' =>$this->service_name['fami'],
                            'method_id' => $this->service_id['fami'],
						    'cost' => $shipping_total
					    );
                        // Register the rate
                        if($total >= $this->min_total)
                            $this->add_rate( $rate );
                    }
                    			
					
				}
                public function add_rate( $args = array() ) {
                    parent::add_rate( $args);
                    if(isset( $this->rates[ $args['id'] ]))
                        $this->rates[ $args['id'] ]->set_method_id($args['method_id']);
                }
                // O_C2CPBe
                // $order_id:qs
                public function isSelectedSmilepayC2Cp($order_id)
                {
                 
                    if(!isset($order_id) || empty($order_id))
                    {
                        return false;
                    }
                    
                    $order = new WC_Order($order_id);
     
                    if(!isset($order) || empty($order))
                        return false;

                    if(is_admin())
                    {
                        $shipping_methods = $order->get_shipping_methods();
		                $has_method = false;
         
		                if ( empty( $shipping_methods ) ) {
			                return false;
		                }

		                foreach ( $shipping_methods as $shipping_method ) {
                            if ( in_array($shipping_method->get_method_id(),$this->service_id)  ) {
				                    return true;
			                }        
		                }
                        return FALSE;

                    }
                    else
                    {
                        foreach($this->service_id as $service_id) 
                        {
                           if( $order->has_shipping_method($service_id ))
                            return true; 
                        }
                        return false;
                    }
                   
                 }

                 public static function isSupport_Service($method_id)
                 {
                     if(in_array($method_id,self::$support_service))
                        return TRUE;
                     return FALSE;
                 } 
                 public static function getSupport_Service()
                 {
                     return self::$support_service;
                 }
                 public static function getCSVServiceArg($method_id)
                 {
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                            return self::$smilepay_payzg_sub_tb[$key];
                     }
                     return FALSE;
                 }

                 public static function getQueryShipmentUrl($method_id)
                 {
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                            return self::$service_cvs_query_shipment_url[$key];
                     }
                     return FALSE;
                 }

                 public static function getCSVServiceName($method_id)
                 {
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                            return  u2bcp(self::$service_cvs_name[$key]);
                     }
                     return FALSE;
                 }
                 
                 public function get_all_categorys()
                 {
                     $args = array(
                               'hierarchical' => 1,
                               'show_option_none' => '',
                               'hide_empty' => 0,
                               'taxonomy' => 'product_cat'
                           );
                     $subcats = get_categories($args);
                     $ret_arr=array();
                     foreach ($subcats as $sc) {
                             $ret_arr[$sc->term_id] = $sc->name;
                     }
                     return $ret_arr;
                 }
                 //emap url
                 public static function getCSVMapUrl($method_id,$ret_url,$note='')
                 {
                     $useragent=$_SERVER['HTTP_USER_AGENT'];
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                         {
                            if(!isset(self::$map_url[$key]))
                                continue;
                            else
                            {
                                
                                if( preg_match('/Android|iPad|iPhone/i',$useragent)  )
                                {
                                    return sprintf(self::$map_url[$key]['mobile'],$note,urlencode($ret_url));
                                }
                                else
                                {
                                    return sprintf(self::$map_url[$key]['normal'],$note,urlencode($ret_url));
                                }
                            }
                         }
                           
                     }
                   
                     return '';
                     
                 }
                 //show emap
                static function shipping_emap_region($method)
                {
                    global $woocommerce;

                    $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
                    
                    if(!empty($chosen_methods) && $chosen_methods[0] == $method->id && self::isSupport_Service($method->id)) 
                    {

                        $ret_url =  get_site_url() ."/?wc-ajax=smilepay_c2cp_save_emap"."&type=".self::$map_save_type[$method->id ] ;
                        $emap_url=self::getCSVMapUrl( $method->id,$ret_url,'');
                        $store_data=self::checkout_load_storedata();

                        echo u2bcp("<button type='button' onclick='window.open(\"".$emap_url."\",\"_self\");'>f</button>");

                        if(self::checkout_is_selected_emap($method->id))
                        {
                            echo u2bcp('<div>fG<span style="color:blue;">').$store_data['storename'].'('.$store_data['storeid'].')<br>'.$store_data['storeaddress'] .'</span></div>';
                        }


                    }  
                }
                static function checkout_load_storedata()
                {
                    $store_data =array();
                    
                    $store_data['storeid']= WC()->session->get( 'smilepay_c2cp_storeid' );
                    $store_data['storename']= WC()->session->get('smilepay_c2cp_storename' );
                    $store_data['storeaddress']= WC()->session->get( 'smilepay_c2cp_storeaddress' );
                    $store_data['type'] = WC()->session->get( 'smilepay_c2cp_type' );
                    return $store_data;
                }
                static function checkout_clear_store_data()
                {
                    WC()->session->__unset( 'smilepay_c2cp_storeid' );
                    WC()->session->__unset( 'smilepay_c2cp_storename' );
                    WC()->session->__unset( 'smilepay_c2cp_storeaddress' );
                    WC()->session->__unset( 'smilepay_c2cp_type' );
                }
                static function checkout_is_selected_emap($method_id)
                {
                    $store_data= self::checkout_load_storedata();
                    
                    if(isset($store_data['type']) &&  isset(self::$support_service[$store_data['type']]) && $method_id == self::$support_service[$store_data['type']] )
                    {
                        if(!empty($store_data['storeid'])&& !empty($store_data['storename'])&& !empty($store_data['storeaddress']))
                            return true;
                    }
                    return false;
                }
                //save emap
                static function ajax_save_emap()
                {
                    global $woocommerce;
                    $checkout_url = wc_get_checkout_url();
                    $store_data=array();
                    if(isset($_REQUEST['storeid']))
                        $store_data['storeid']=$_REQUEST['storeid'];
                    if(isset($_REQUEST['storename']))
                        $store_data['storename']=$_REQUEST['storename'];
                    if(isset($_REQUEST['storeaddress']))
                        $store_data['storeaddress']=$_REQUEST['storeaddress'];
                    if(isset($_REQUEST['type']))
                        $store_data['type']=$_REQUEST['type'];
                    
                    self::checkout_save_storedata($store_data);
                    wp_redirect($checkout_url);
                    die();
                }
                static function checkout_save_storedata($store_data)
                {
                    if(isset($store_data['storeid']))
                         WC()->session->set( 'smilepay_c2cp_storeid',$store_data['storeid'] );
                    if(isset($store_data['storename']))
                         WC()->session->set( 'smilepay_c2cp_storename',$store_data['storename'] );
                    if(isset($store_data['storeaddress']))
                         WC()->session->set( 'smilepay_c2cp_storeaddress',$store_data['storeaddress'] );
                    if(isset($store_data['type']))
                         WC()->session->set( 'smilepay_c2cp_type',$store_data['type'] );

                }
                //hook sava order store data
                /*static function checkout_save_storedata_to_order($order_id, $posted_data, $order)
                {

                    if(empty($order))
                        $order = new WC_Order($order_id);

                    $shipping_method = @array_shift($order->get_shipping_methods());
                    $shipping_method_id = $shipping_method['method_id'];
                    if(self::isSupport_Service($shipping_method_id))
                    {
                        $store_data=self::checkout_load_storedata();
                        self::save_storedata_by_orderid($order_id,$store_data);
                        self::checkout_clear_store_data();
                        //$msg= 'G'.$store_data['storename'].'('.$store_data['storeid'].')<br>'."a}G".$store_data['storeaddress'];
                        //$order->add_order_note( $msg,"1");
                        $order->set_shipping_address_1($store_data['storeaddress']);
                        $order->save();
                    }
                    
                }*/

                function save_storedata_by_orderid($order_id=0,$store_data=array())
                {
                    self::_save_storedata_by_orderid($order_id,$store_data);
                }

                function load_storedata_by_orderid($order_id=0)
                {
                    return self::_load_storedata_by_orderid($order_id);
                }

                static function _save_storedata_by_orderid($order_id=0,$store_data=array())
                {
                    if(!empty($order_id))
                    {

                        if( isset($store_data['storeid'])&&isset($store_data['storename'])&&isset($store_data['storeaddress'])){
                            $data=$store_data['storeid'] .'/'.$store_data['storename'] .'/'.$store_data['storeaddress'];
                            update_post_meta( $order_id, 'smilepay_c2cp_storedata',$data );
                        }
                            
                    }
                }

                function _load_storedata_by_orderid($order_id=0)
                {
                    if(!empty($order_id))
                    {
                        $data=get_post_meta( $order_id, 'smilepay_c2cp_storedata',true);
                        $storedata_tmp=explode('/',$data);
                      
                        if(count($storedata_tmp)!=3)
                        {
                            $store_data['storeid']='';
                            $store_data['storename']=''; 
                            $store_data['storeaddress']='';
                        }
                        else
                        {
                            $store_data['storeid']=$storedata_tmp[0];
                            $store_data['storename']=$storedata_tmp[1]; 
                            $store_data['storeaddress']=$storedata_tmp[2];
                        }
                        
                        return $store_data;
                        
                    }
                    return NULL;
                }

                public static function get_order_smseid($order_id)
                {
                    return get_post_meta( $order_id, 'Smilepay_c2cp_SMSEID', true );
                }
                public static function set_order_smseid($order_id,$smseid)
                {
                    return update_post_meta( $order_id, 'Smilepay_c2cp_SMSEID', $smseid );
                }

                public static function get_order_tracknum($order_id)
                {
                    return get_post_meta( $order_id, 'Smilepay_c2cp_TRACKNUM', true );
                }
                public static function set_order_tracknum($order_id,$smseid)
                {
                    return update_post_meta( $order_id, 'Smilepay_c2cp_TRACKNUM', $smseid );
                }


			}
		}

	}
 
	add_action( 'woocommerce_shipping_init', 'Smilepayc2cp_shipping_method_init' );
    
 
	function add_Smilepayc2cp_shipping_method( $methods ) {
        //fill this->id for woocommerce2.6 modify
		//$methods[] = 'WC_Smilepayc2cp_Shipping_Method';
        $methods['smilepay_711_c2c_shippingpay'] = 'WC_Smilepayc2cp_Shipping_Method';
		return $methods;
	}
 
	add_filter( 'woocommerce_shipping_methods', 'add_Smilepayc2cp_shipping_method' );

}
function u2bcp($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2ucp($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
